# std::__debug::bitset< _Nb >::reference Class Reference

Inheritance diagram for std::__debug::bitset< _Nb >::reference:

List of all members.

## Detailed Description

### template<size_t _Nb>
class std::__debug::bitset< _Nb >::reference

Definition at line 56 of file debug/bitset.

## Public Member Functions

- void _M_attach (_Safe_sequence_base *__seq, bool __constant)
- void _M_attach_single (_Safe_sequence_base *__seq, bool __constant)
- bool _M_attached_to (const _Safe_sequence_base *__seq) const
- bool _M_can_compare (const _Safe_iterator_base &__x) const
- void _M_detach ()
- void _M_detach_single ()
- bool _M_singular () const
- reference & flip ()
- operator bool () const
- reference & operator= (const reference &__x)
- reference & operator= (bool __x)
- bool operator~ () const
- reference (const reference &__x)

## Public Attributes

- _Safe_iterator_base * _M_next
- _Safe_iterator_base * _M_prior
- _Safe_sequence_base * _M_sequence
- unsigned int _M_version

## Protected Member Functions

- __gnu_cxx::__mutex & _M_get_mutex ()

## Friends

- class bitset

## Member Function Documentation

void __gnu_debug::_Safe_iterator_base::_M_attach | ( | _Safe_sequence_base * | __seq,
|  | bool | __constant |
| ) |  |  | `[inherited]`

Attaches this iterator to the given sequence, detaching it from whatever sequence it was attached to originally. If the new sequence is the NULL pointer, the iterator is left unattached.

Referenced by __gnu_debug::_Safe_iterator< _Iterator, _Sequence >::_M_attach(), and __gnu_debug::_Safe_iterator_base::_Safe_iterator_base().

void __gnu_debug::_Safe_iterator_base::_M_attach_single | ( | _Safe_sequence_base * | __seq,
|  | bool | __constant |
| ) |  |  | `[inherited]`

Likewise, but not thread-safe.

Referenced by __gnu_debug::_Safe_iterator< _Iterator, _Sequence >::_M_attach_single().

bool __gnu_debug::_Safe_iterator_base::_M_attached_to | ( | const _Safe_sequence_base * | __seq | ) | const`[inline, inherited]`

Determines if we are attached to the given sequence.

Definition at line 135 of file safe_base.h.

References __gnu_debug::_Safe_iterator_base::_M_sequence.

Referenced by std::__debug::list< _Tp, _Allocator >::splice().

bool __gnu_debug::_Safe_iterator_base::_M_can_compare | ( | const _Safe_iterator_base & | __x | ) | const`[inherited]`

Can we compare this iterator to the given iterator `__x`? Returns true if both iterators are nonsingular and reference the same sequence.

Referenced by __gnu_debug::_Safe_iterator< _Iterator, _Sequence >::_M_valid_range(), __gnu_debug::operator!=(), __gnu_debug::operator-(), __gnu_debug::operator==(), __gnu_debug::operator>(), and __gnu_debug::operator>=().

void __gnu_debug::_Safe_iterator_base::_M_detach | ( |  | ) | `[inherited]`

Detach the iterator for whatever sequence it is attached to, if any.

Referenced by __gnu_debug::_Safe_iterator_base::~_Safe_iterator_base().

void __gnu_debug::_Safe_iterator_base::_M_detach_single | ( |  | ) | `[inherited]`

Likewise, but not thread-safe.

__gnu_cxx::__mutex& __gnu_debug::_Safe_iterator_base::_M_get_mutex | ( |  | ) | `[protected, inherited]`

For use in _Safe_iterator.

bool __gnu_debug::_Safe_iterator_base::_M_singular | ( |  | ) | const`[inherited]`

Is this iterator singular?

Referenced by __gnu_debug::__check_singular(), __gnu_debug::__check_singular_aux(), __gnu_debug::_Safe_iterator< _Iterator, _Sequence >::_M_decrementable(), __gnu_debug::_Safe_iterator< _Iterator, _Sequence >::_M_dereferenceable(), __gnu_debug::_Safe_iterator< _Iterator, _Sequence >::_Safe_iterator(), __gnu_debug::operator!=(), __gnu_debug::operator-(), __gnu_debug::_Safe_iterator< _Iterator, _Sequence >::operator=(), std::__debug::bitset< _Nb >::reference::operator=(), __gnu_debug::operator==(), __gnu_debug::operator>(), and __gnu_debug::operator>=().

## Member Data Documentation

_Safe_iterator_base* __gnu_debug::_Safe_iterator_base::_M_next`[inherited]`

Pointer to the next iterator in the sequence's list of iterators. Only valid when _M_sequence != NULL.

Definition at line 78 of file safe_base.h.

Referenced by __gnu_debug::_Safe_iterator< _Iterator, _Sequence >::_M_invalidate_single().

_Safe_iterator_base* __gnu_debug::_Safe_iterator_base::_M_prior`[inherited]`

Pointer to the previous iterator in the sequence's list of iterators. Only valid when _M_sequence != NULL.

Definition at line 74 of file safe_base.h.

_Safe_sequence_base* __gnu_debug::_Safe_iterator_base::_M_sequence`[inherited]`

The sequence this iterator references; may be NULL to indicate a singular iterator.

Definition at line 61 of file safe_base.h.

Referenced by __gnu_debug::_Safe_iterator_base::_M_attached_to(), __gnu_debug::_Safe_iterator< _Iterator, _Sequence >::_M_can_advance(), __gnu_debug::_Safe_iterator< _Iterator, _Sequence >::_M_get_sequence(), __gnu_debug::_Safe_iterator< _Iterator, _Sequence >::_M_invalidate_single(), __gnu_debug::_Safe_iterator< _Iterator, _Sequence >::_M_is_begin(), __gnu_debug::_Safe_iterator< _Iterator, _Sequence >::_M_is_end(), __gnu_debug::_Safe_sequence< _Sequence >::_M_transfer_iter(), __gnu_debug::_Safe_iterator_base::_Safe_iterator_base(), and __gnu_debug::_Safe_iterator< _Iterator, _Sequence >::operator=().

unsigned int __gnu_debug::_Safe_iterator_base::_M_version`[inherited]`

The version number of this iterator. The sentinel value 0 is used to indicate an invalidated iterator (i.e., one that is singular because of an operation on the container). This version number must equal the version number in the sequence referenced by _M_sequence for the iterator to be non-singular.

Definition at line 70 of file safe_base.h.

Referenced by __gnu_debug::_Safe_iterator< _Iterator, _Sequence >::_M_invalidate_single().

The documentation for this class was generated from the following file:

- debug/bitset